%define ltversion 1.5
%define libtool libtool-%ltversion
%define libltdl libltdl
%define priority 150

Name: libtool_%ltversion
Version: 1.5.18
Release: alt2
Serial: 3

Summary: The GNU libtool, which simplifies the use of shared libraries
License: GPL
Group: Development/Other
Url: http://www.gnu.org/software/libtool/libtool.html
Packager: Libtool Development Team <libtool@packages.altlinux.org>

%set_compress_method gzip
%define do_check 0
%{?!__buildreqs:%{?!_without_check:%{?!_disable_check:%global do_check 1}}}

Provides: libtool = %serial:%version-%release
PreReq: libtool-common >= 0.2, alternatives >= 0:0.2.0-alt0.12
Requires(post): %install_info
Requires(preun): %uninstall_info
Requires: aclocal(libtool)
Requires: autoconf_2.5 >= 2:2.59-alt2
Obsoletes: libtool

Source: ftp://ftp.gnu.org/gnu/libtool/libtool-%version.tar.bz2
Source1: %name-buildreq-ignore

# Debian patches
Patch11: libtool-1.5.18-deb-ltdl.patch
Patch12: libtool-1.5.18-deb-ltmain-version_type.patch

# Owl patches
Patch16: libtool-1.5.18-owl-buildhost.patch

# ALT patches
Patch21: libtool-1.5.18-alt-tmp.patch
Patch22: libtool-1.5.18-alt-ltmain-legacy.patch
Patch23: libtool-1.5.18-alt-texinfo.patch
Patch24: libtool-1.5.18-alt-libtoolize-libtool.m4.patch
Patch25: libtool-1.5.18-alt-deb-link_all_deplibs.patch
Patch26: libtool-1.5.18-alt-link_all_deplibs-runtime.patch
Patch27: libtool-1.5.18-alt-cxx.patch

BuildRequires: gcc-c++, gcc-g77, libalternatives-devel

%package -n %libltdl
Summary: dlopen wrapper for GNU libtool
License: LGPL
Group: System/Libraries
Provides: libtool-libs = %serial:%version-%release
Obsoletes: libtool-libs

%package -n %libltdl-devel
Summary: Development files for %libltdl
License: LGPL
Group: Development/C
Requires: %libltdl = %serial:%version-%release
Provides: libtool-devel = %serial:%version-%release
Obsoletes: libtool-devel

%package -n %libltdl-devel-static
Summary: Static %libltdl library
License: LGPL
Group: Development/C
Requires: %libltdl-devel = %serial:%version-%release

%package -n libtool-demos
Summary: Samples for Libtool
License: GPL
Group: Development/Other
Requires: %name = %serial:%version-%release

%description
The libtool package contains the GNU libtool, a set of shell scripts
which automatically configure UNIX and UNIX-like architectures to
generically build shared libraries.  Libtool provides a consistent,
portable interface which simplifies the process of using shared
libraries.

If you are developing programs which will use shared libraries, you
should install libtool.

%description -n %libltdl
This package contains libltdl shared library,
a system independent dlopen wrapper for GNU libtool.

%description -n %libltdl-devel
Development files for libltdl, a system independent
dlopen wrapper for GNU libtool.

%description -n %libltdl-devel-static
Static libltdl library, a system independent dlopen wrapper for GNU libtool.

%description -n libtool-demos
Sample programs and libraries to build with libtool.

%prep
%setup -q -n libtool-%version

# RedHat patches

# Debian patches
%patch11 -p1
%patch12 -p1

# Owl patches
%patch16 -p1

# ALT patches
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1

find -type f -name \*.orig -delete -print

# fix testsuite
find -type f -name configure\* -print0 |
	xargs -r0 fgrep -lZ AM_CONFIG_HEADER -- |
	xargs -r0 subst -p s/AM_CONFIG_HEADER/AC_CONFIG_HEADERS/g --

# fix ld.so.conf.d support
find -type f -print0 |
	xargs -r0 fgrep -lZ 'cd /etc; cat %s' -- |
	xargs -r0 subst -p 's|cd /etc; cat %s|cd /etc \&\& cat %s 2>/dev/null|g' --

# Hack in the version-specific package data dir and aclocal dir variables.
perl -pi -e 's|^(pkgdatadir=.*?)\s*$|$1-%ltversion\n|;' configure.ac

# Fix default vendor and lsattr.
%__subst -p 's|=pc|=%_vendor|g; s|/usr/sbin/lsattr|%_bindir/lsattr|g;' config.guess

for f in config.guess config.sub; do
	ln -snf ../"$f" libltdl/
done

rm -f doc/*.info*

bzip2 -9k ChangeLog*

%build
%undefine __libtoolize
export CC=gcc
export CXX=g++
export F77=g77
export GCJ=gcj

autoreconf -isv
for d in *demo*; do
	ln -snf ../acinclude.m4 "$d"/
	autoreconf -isv "$d"
	ln -snf ../aclocal.m4 "$d"/
done

%configure --program-suffix=-%ltversion

%__perl -pi -e '/^\@direntry/../^\@end direntry/ and s/^\*\s*(libtool(ize)?):\s*\(libtool\)/* $1-%ltversion: (%libtool)/i' doc/libtool.texi

# SMP-incompatible build?
make MAKEINFOFLAGS=--no-split
#%__subst "s/`hostname`/%buildhost/g" libtool
%if %do_check
%make_build -k check
#VERBOSE=yes make -k check
%endif

%install
%makeinstall

%__mv $RPM_BUILD_ROOT%_datadir/libtool/* \
      $RPM_BUILD_ROOT%_datadir/%libtool/

%__mkdir $RPM_BUILD_ROOT%_datadir/%libtool/aclocal
%__mv $RPM_BUILD_ROOT%_datadir/aclocal/libtool.m4 \
    $RPM_BUILD_ROOT%_datadir/%libtool/aclocal/

%__mv $RPM_BUILD_ROOT%_infodir/libtool{,-%ltversion}.info

for f in config.guess config.sub ltmain.sh; do
	ln -snf ../"$f" $RPM_BUILD_ROOT%_datadir/%libtool/libltdl/
done

%__mkdir_p $RPM_BUILD_ROOT%_altdir
cat >$RPM_BUILD_ROOT%_altdir/%name <<EOF
%_bindir/libtool-default	%_bindir/%libtool	%priority
%_bindir/libtoolize-default	%_bindir/libtoolize-%ltversion	%_bindir/%libtool
%_datadir/libtool	%_datadir/%libtool	%_bindir/%libtool
%_infodir/libtool.info.gz	%_infodir/%libtool.info.gz	%_bindir/%libtool
EOF

%__mkdir_p $RPM_BUILD_ROOT%_sysconfdir/buildreqs/packages/substitute.d
echo libtool >$RPM_BUILD_ROOT%_sysconfdir/buildreqs/packages/substitute.d/%name

%__install -pD -m644 %SOURCE1 \
	$RPM_BUILD_ROOT%_sysconfdir/buildreqs/files/ignore.d/%name

%define ltdocdir %_docdir/libtool-%version
%define ltdldocdir %_docdir/libltdl-%version

%__mkdir_p $RPM_BUILD_ROOT%ltdocdir
%__install -p -m644 acinclude.m4 aclocal.m4 AUTHORS NEWS README THANKS TODO ChangeLog*.bz2 \
    $RPM_BUILD_ROOT%ltdocdir/
%__ln_s -f %_licensedir/GPL-2 $RPM_BUILD_ROOT%ltdocdir/COPYING
%__mkdir_p $RPM_BUILD_ROOT%ltdldocdir
%__install -p -m644 libltdl/README $RPM_BUILD_ROOT%ltdldocdir/
%__rm -f $RPM_BUILD_ROOT%_datadir/%libtool/libltdl/COPYING.LIB
%__ln_s -f %_licensedir/LGPL-2.1 $RPM_BUILD_ROOT%_datadir/%libtool/libltdl/COPYING.LIB
%__ln_s -f %_licensedir/LGPL-2.1 $RPM_BUILD_ROOT%ltdldocdir/COPYING.LIB
for d in *demo*; do
	%__cp -a "$d" $RPM_BUILD_ROOT%ltdocdir/
%if %do_check
	make -C $RPM_BUILD_ROOT%ltdocdir/"$d" distclean
%endif
	%__rm -rf $RPM_BUILD_ROOT%ltdocdir/"$d"/autom4te.cache
done
%__cp -p install-sh missing $RPM_BUILD_ROOT%ltdocdir/demo/

%post -n %libltdl -p %post_ldconfig
%postun -n %libltdl -p %postun_ldconfig

%post
%install_info %libtool.info
%register_alternatives %name
%__install_info \
	--info-file=%_infodir/libtool.info \
	--info-dir=%_infodir \
	--section=Development/Other \
	--entry="* Libtool: (libtool).                           Generic shared library support script." \
	--entry="* libtoolize: (libtool)Invoking libtoolize.     Adding libtool support." \
	||:

%preun
[ $1 = 0 ] || exit 0
%uninstall_info %libtool.info
%unregister_alternatives %name
if [ ! -e %_infodir/libtool.info.gz ]; then
	%__install_info \
		--delete \
		--info-file=%_infodir/libtool.info \
		--info-dir=%_infodir
fi

%triggerpostun -- libtool
%register_alternatives %name
%__install_info \
	--info-file=%_infodir/libtool.info \
	--info-dir=%_infodir \
	--section=Development/Other \
	--entry="* Libtool: (libtool).                           Generic shared library support script." \
	--entry="* libtoolize: (libtool)Invoking libtoolize.     Adding libtool support." \
	||:
for f in ltmain.sh config.{guess,sub}; do
    %__ln_s -f $f-%ltversion %_datadir/%libtool/$f
done


%files
%_bindir/*
%_datadir/%libtool
%_infodir/%libtool.info*
%_altdir/%name
%config %_sysconfdir/buildreqs/packages/substitute.d/%name
%config %_sysconfdir/buildreqs/files/ignore.d/%name
%dir %ltdocdir
%ltdocdir/[A-Z]*

%files -n %libltdl
%_libdir/*.so.*
%dir %ltdldocdir
%ltdldocdir/README
%ltdldocdir/COPYING.LIB

%files -n %libltdl-devel
%_libdir/*.so
%_includedir/*
%_datadir/aclocal/ltdl.m4

%files -n %libltdl-devel-static
%_libdir/*.a

%files -n libtool-demos
%dir %ltdocdir
%ltdocdir/*.m4
%ltdocdir/*demo*

%changelog
* Thu May 26 2005 Dmitry V. Levin <ldv@altlinux.org> 3:1.5.18-alt2
- Corrected License tags (#6704).
- Rediffed patches.

* Wed May 18 2005 Dmitry V. Levin <ldv@altlinux.org> 3:1.5.18-alt1
- Updated to 1.5.18.

* Tue Apr 26 2005 Dmitry V. Levin <ldv@altlinux.org> 3:1.5.16-alt1
- Updated to 1.5.16.
- Updated link_all_deplibs patch.

* Sun Feb 13 2005 Dmitry V. Levin <ldv@altlinux.org> 3:1.5.14-alt1
- Updated to 1.5.14.

* Sun Feb 06 2005 Dmitry V. Levin <ldv@altlinux.org> 3:1.5.12-alt1
- Updated to 1.5.12.
- Rediffed few patches, dropped obsolete RH patches.
- Dropped custom ld.so.conf include syntax support,
  in favour of upstream solution for the same issue.
- Converted alternatives config file to new format (0.2.0).

* Sun Nov 28 2004 Dmitry V. Levin <ldv@altlinux.org> 3:1.5.10-alt1
- Updated to 1.5.10.
- Enhanced CXX fix introduced in this version.
- Backported ltmain.in func_mode_link fix from libtool cvs.
- Applied patch from Owl to prevent build host name leaks
  into the generated libtool script.
- Disabled alt-ltmain-cpp-linkage hack,
  hopefully no longer needed.
- Implemented ld.so.conf include syntax support.

* Mon Aug 09 2004 Dmitry V. Levin <ldv@altlinux.org> 3:1.5.8-alt1
- Updated to 1.5.8.

* Tue Apr 13 2004 Dmitry V. Levin <ldv@altlinux.org> 3:1.5.6-alt1
- Updated to 1.5.6.

* Thu Apr 08 2004 Dmitry V. Levin <ldv@altlinux.org> 3:1.5.4-alt2
- Updated legacy patch (added shrext_cmds initialization).
- Applied fix for LTDL_SHLIB_EXT initialization from upstream.

* Wed Apr 07 2004 Dmitry V. Levin <ldv@altlinux.org> 3:1.5.4-alt1
- Updated to 1.5.4, updated patches.
- Updated link_all_deplibs patch (Scott James Remnant).
- Applied ltdl fix (Scott James Remnant).

* Thu Feb 26 2004 Dmitry V. Levin <ldv@altlinux.org> 3:1.5.2-alt2
- libtool-demo: do not package obsolete mkinstalldirs.

* Wed Feb 04 2004 Dmitry V. Levin <ldv@altlinux.org> 3:1.5.2-alt1
- Updated to 1.5.2.
- Merged upstream patches:
  jh-expsym-linux
  rh-readonlysym
  rh-relink-libdir-order-91110
  rh-AC_PROG_LD_GNU-quote-v-97608
  rh-nostdlib
- Applied additional link_all_deplibs-runtime patch
  from Alexey Morozov.
- Disabled alt-tagconfig-deps patch for a while,
  it causes unwanted side effects.
- Added requires on fixed autoconf so #3414 will not arise
  again in its worst form.

* Mon Dec 29 2003 Dmitry V. Levin <ldv@altlinux.org> 3:1.5-alt11
- libtool.m4:_LT_AC_TAGCONFIG: fixed dependence loop problem
  (#3414).

* Tue Dec 02 2003 Dmitry V. Levin <ldv@altlinux.org> 3:1.5-alt10
- Rewritten ltmain tmp handling fix.
- Ensure that EGREP and max_cmd_len variables are defined
  in ltmain, to support legacy configure scripts.

* Sun Nov 30 2003 Dmitry V. Levin <ldv@altlinux.org> 3:1.5-alt9
- libltdl-devel: do not package .la files.

* Sun Nov 16 2003 Dmitry V. Levin <ldv@altlinux.org> 3:1.5-alt8
- Set link_all_deplibs=no for linux, to avoid linking a program
  against all its dependency lib tree.

* Wed Aug 20 2003 Dmitry V. Levin <ldv@altlinux.org> 3:1.5-alt7
- Additional convention enforcement on patch file names.
- Raised serial number.

* Wed Aug 20 2003 Mikhail Zabaluev <mhz@altlinux.ru> 2:1.5-alt6
- Reverted to libltdl
- Corrected libtoolize to expect ltdl.m4 in %_datadir/aclocal

* Tue Aug 19 2003 Dmitry V. Levin <ldv@altlinux.org> 2:1.5-alt5
- Renamed libltdl to libltdl3.
- Updated interpackage dependencies.
- Updated build dependencies.
- Deal with info dir entries such that the menu looks pretty.
- Do not create %_datadir/%libtool/aclocal/ltdl.m4 symlink
  (may reference to non-existing file).

* Tue Aug 19 2003 Mikhail Zabaluev <mhz@altlinux.ru> 2:1.5-alt4
- Renamed to libtool_1.5 to install together with legacy libtool_1.4.
  Paths modified accordingly. libltdl is left unsplit though.
- Moved demos to a dedicated package named libtool-demos
- Corrected descriptions for libltdl

* Sat Aug 16 2003 Mikhail Zabaluev <mhz@altlinux.ru> 2:1.5-alt3
- Define SED in ltmain.sh for legacy ltconfig's [Patch0]
- Disable distclean'ing of demo subdirs if check target has not been made

* Wed Aug 13 2003 Dmitry V. Levin <ldv@altlinux.org> 2:1.5-alt2
- Updated package dependencies.
- Updated build dependencies.
- Minor specfile cleanup.

* Sat Aug 09 2003 Mikhail Zabaluev <mhz@altlinux.ru> 2:1.5-alt1
- New version
- Synchronized with RedHat package 1.5-5
- Override compiler tests in configure
- Bzip the changelogs
- Symlink the licenses to the shared license directory

* Sun Sep 22 2002 Mikhail Zabaluev <mhz@altlinux.ru> 2:1.4.2-alt0.2
- Replaced/appended patches with the RedHat patches from 1.4.2-12,
  save the X11R6 patch. RedHat should be the proper reference for patches,
  they do it cleaner, plus they have aoliva among them.
- Reversed the order in -L directories for the relink patch
  so that the inst-prefixed directory comes first
  (this is not apparent from the code, because the order of linking items
  is reversed afterwards)
- The tag patch is moot, as it changes two independent things and introduces
  an option yet unused. Let it dangle unapplied for now.
- Replaced the ugly c++ link patch from Mandrake
  with something more elegant

* Thu Jun 13 2002 Mikhail Zabaluev <mhz@altlinux.ru> 2:1.4.2-alt0.1
- 1.4.2
- Patches from Mandrake, including the relink patch

* Mon Sep 03 2001 Dmitry V. Levin <ldv@altlinux.ru> 1.4-alt2
- Do not infer tagged configuration yet.

* Thu Aug 23 2001 Dmitry V. Levin <ldv@altlinux.ru> 1.4-alt1
- Revert back again to more stable(?) version.
- Readded k6/athlon arches support.

* Fri Aug 17 2001 Dmitry V. Levin <ldv@altlinux.ru> 1.4b-alt1
- 1.4b
- libtool_1.4b-3 patch from debian.
- Added more demos to libltdl-devel subpackage

* Tue May 15 2001 Dmitry V. Levin <ldv@altlinux.ru> 1.3.5-alt2
- More architectures support (debian).

* Fri May 11 2001 Dmitry V. Levin <ldv@altlinux.ru> 1.3.5-alt1
- Back to 1.3.5 (1.4 seems to be broken).

* Sat May 05 2001 Dmitry V. Levin <ldv@altlinux.ru> 1.4-alt1
- 1.4
- Libificated into libtool, libltdl, libltdl-devel-static and libltdl-devel-static subpackages.
- Do not libtoolize during build.

* Wed Nov 15 2000 Dmitry V. Levin <ldv@fandra.org> 1.3.5-ipl3mdk
- Fixed texinfo documentation.
- Added fake "--build" option.

* Fri Sep 29 2000 Dmitry V. Levin <ldv@fandra.org> 1.3.5-ipl2mdk
- Merged with RH.
- Re-splitted into libtool and libtool-libs.

* Mon Jun 26 2000 Dmitry V. Levin <ldv@fandra.org> 1.3.5-ipl1mdk
- RE and Fandra adaptions.

* Wed Jun 21 2000 Geoffrey Lee <snailtalk@linux-mandrake.com> 1.3.5-1mdk
- picks up $arch-mandrake-linux-gnu not $arch-pc-linux-gnu (patch)
  well, for x86 and alpha anyway, maybe ultrasparc too ??
- new version
- fix bad source url
- add libtool url
- add devel package
- Chmouel Boudjnah <chmouel@mandrakesoft.com> - Spec Cleanup
  (makeinstall etc..).

* Wed Apr  5 2000 Jeff Garzik <jgarzik@mandrakesoft.com> 1.3.4-2mdk
- updated BuildRoot
- group new Development/Other

* Thu Jan 13 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 1.3.4-1mdk
- 1.3.4.

* Wed Dec  1 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Build Release.

* Sun Nov 07 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Build release.

* Mon Oct 25 1999  Jeff Garzik  <jgarzik@pobox.com>
- Import RedHat 6.1 spec
- s/gzip/bzip2/ for info documentation

* Thu Jul 15 1999 Jeff Johnson <jbj@redhat.com>
- update to 1.3.3.

* Mon Jun 14 1999 Jeff Johnson <jbj@redhat.com>
- update to 1.3.2.

* Tue May 11 1999 Jeff Johnson <jbj@redhat.com>
- explicitly disable per-arch libraries (#2210)
- undo hard links and remove zero length file (#2689)

* Sat May  1 1999 Jeff Johnson <jbj@redhat.com>
- update to 1.3.

* Fri Mar 26 1999 Cristian Gafton <gafton@redhat.com>
- disable the --cache-file passing to ltconfig; this breaks the older
  ltconfig scripts found around.

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com>
- auto rebuild in the new build environment (release 2)

* Fri Mar 19 1999 Jeff Johnson <jbj@redhat.com>
- update to 1.2f

* Tue Mar 16 1999 Cristian Gafton <gafton@redhat.com>
- completed arm patch
- added patch to make it more arm-friendly
- upgrade to version 1.2d

* Thu May 07 1998 Donnie Barnes <djb@redhat.com>
- fixed busted group

* Sat Jan 24 1998 Marc Ewing <marc@redhat.com>
- Update to 1.0h
- added install-info support

* Tue Nov 25 1997 Elliot Lee <sopwith@redhat.com>
- Update to 1.0f
- BuildRoot it
- Make it a noarch package
